function M = ref_distr( A, p, q, type )

 t     = p*q; 
[m, n] = size(A);

switch type
  case 'cols'
    idx = reshape(1:n,t,n/t)'; idx=idx(:)';
    M   = A(:,idx);
  case 'rows'
    idx = reshape(1:m,t,m/t)'; idx=idx(:)';
    M   = A(idx,:);
  case '2D'
    idx1= reshape(1:m,p,m/p)'; idx1=idx1(:)';
    idx2= reshape(1:n,q,n/q)'; idx2=idx2(:)';
    M   = A(idx1,idx2);
  otherwise
    error('Distribution not known');
end

end







%%
% n=24;  p=2;  q=3;  t=p*q; 
% A=ones(6,1)*[1:n]; 
% B=[1:n]'*ones(1,6);
% C=reshape(1:120,10,12);

% idx = reshape(1:n,t,n/t)'; idx=idx(:)';
% M1 = A(:,idx);
% M2 = B(idx,:);

% [m,n]=size(C);
% idx1 = reshape(1:m,p,m/p)'; idx1=idx1(:)';
% idx2 = reshape(1:n,q,n/q)'; idx2=idx2(:)';
% M3 = C(idx1,idx2);



%%  loops
%b=n/t;
%for i=1:t,
%    M( :, b*(i-1)+1:b*i ) = A( :, i:t:end );
%end






