function y = ref_MV_fast( n, v )
    y=zeros(n,1);
    if mod(n,2) == 0,
        h = n/2;
        y(1:h)   = 4*v(1:h)    +   v(end:-1:h+1);
        y(h+1:n) = 3*v(h:-1:1) + 2*v(h+1:end); 
    else
        h = (n+1)/2;
        
        y(1:h-1) = 7*v(1:h-1)      + 8*v(h) +   v(end:-1:h+1);  
        y(h)     = 6*sum(v(1:h-1)) + 0      + 2*sum(v(h+1:end));
        y(h+1:n) = 5*v(h-1:-1:1)   + 4*v(h) + 3*v(h+1:end); 
    end
end 
